=== requirements.txt ===
future
numpy
pyyaml
requests
setuptools
six
typing_extensions
dataclasses; python_version<"3.7"
