=== .circleci/ecr_gc_docker/requirements.txt ===
boto3
pytz
requests
