=== debian/changelog ===
pytorch (1.8.1-4) unstable; urgency=medium

  * B-D on python3-dev instead of -all-dev. (Closes: #1004331)
    We only build with one Py3 version due to the buildsystem complexity.
  * Explicitly fix python and shell shebang in d/rules.
  * Fix superfluous-file-pattern in d/copyright.
  * Fix duplicate-short-description in d/control.
  * Bump Standards-Version to 4.6.0.1 (no change).
  * Update lintian overrides.

 -- Mo Zhou <lumin@debian.org>  Tue, 01 Feb 2022 20:11:00 -0500

pytorch (1.8.1-3) unstable; urgency=medium

  * Add comments in d/rules on package maintainence.
  * Mask python spectral_ops test which requires MKL. (Closes: #995360)
  * Mask python binary_ufuncs autopkgtest.
  * Only build on modern 64-bit architectures. (Closes: #994423)
  * Add missing Dep libprotobuf-dev for libtorch-dev.
  * d/watch: Track releases instead of tags.

 -- Mo Zhou <lumin@debian.org>  Sun, 23 Jan 2022 09:14:58 -0500

pytorch (1.8.1-2) unstable; urgency=medium

  * Upload to unstable.
  * Let python3-torch Depend on libtorch-test to fix broken link.
    (Closes: #988778)

 -- Mo Zhou <lumin@debian.org>  Mon, 06 Sep 2021 00:22:04 -0400

pytorch (1.8.1-1) experimental; urgency=medium

  [ Michael R. Crusoe ]
  * Mark libtorch1.7 as Multi-Arch: same

  [ Mo Zhou ]
  * New upstream version 1.8.1
  * Upgrade embedded foxi to 6a4e19a2aaf7ae4b9fa9597526e65b395d5e79ad.
  * Rebase dirtyhack.patch.
  * Add libnuma-dev to Build-Depends.
  * SOVERION bump for binary packages.
  * Refresh shebang.patch and other existing patches.
  * Refresh autopkgtest control file.

 -- Mo Zhou <lumin@debian.org>  Fri, 21 May 2021 14:20:58 +0800
