=== debian/tests/control ===
# Sanity test of python package
Test-Command: cd test/ ; python3 -c "import sys, torch as th; print(sys.version, th.__path__, th.__version__)"
Depends: python3-torch,
Restrictions: allow-stderr

# Generating Autopkgtest Test Cases for the C++ Testing Programs
# Found 147 tests
#
# C++ test 0/147
Test-Command: /usr/lib/libtorch-test/AlgorithmsTest
Depends: build-essential, ninja-build, libtorch-dev, libtorch-test
Features: test-name=1_of_147__cpptest__AlgorithmsTest
Restrictions: allow-stderr

# C++ test 1/147
Test-Command: /usr/lib/libtorch-test/BinaryMatchImplTest
Depends: build-essential, ninja-build, libtorch-dev, libtorch-test
Features: test-name=2_of_147__cpptest__BinaryMatchImplTest
Restrictions: allow-stderr

# C++ test 2/147
Test-Command: /usr/lib/libtorch-test/CppSignature_test
Depends: build-essential, ninja-build, libtorch-dev, libtorch-test
Features: test-name=3_of_147__cpptest__CppSignature_test
Restrictions: allow-stderr

# C++ test 3/147
Test-Command: /usr/lib/libtorch-test/Dict_test
Depends: build-essential, ninja-build, libtorch-dev, libtorch-test
Features: test-name=4_of_147__cpptest__Dict_test
Restrictions: allow-stderr

# C++ test 4/147
Test-Command: /usr/lib/libtorch-test/Dimname_test
Depends: build-essential, ninja-build, libtorch-dev, libtorch-test
Features: test-name=5_of_147__cpptest__Dimname_test
Restrictions: allow-stderr

# C++ test 5/147
Test-Command: /usr/lib/libtorch-test/GraphTest
Depends: build-essential, ninja-build, libtorch-dev, libtorch-test
Features: test-name=6_of_147__cpptest__GraphTest
Restrictions: allow-stderr

# C++ test 6/147
Test-Command: /usr/lib/libtorch-test/KernelFunction_test
Depends: build-essential, ninja-build, libtorch-dev, libtorch-test
Features: test-name=7_of_147__cpptest__KernelFunction_test
Restrictions: allow-stderr

# C++ test 7/147
Test-Command: /usr/lib/libtorch-test/List_test
Depends: build-essential, ninja-build, libtorch-dev, libtorch-test
Features: test-name=8_of_147__cpptest__List_test
Restrictions: allow-stderr

# C++ test 8/147
Test-Command: /usr/lib/libtorch-test/MatchTest
Depends: build-essential, ninja-build, libtorch-dev, libtorch-test
Features: test-name=9_of_147__cpptest__MatchTest
Restrictions: allow-stderr

# C++ test 9/147
Test-Command: /usr/lib/libtorch-test/NamedTensor_test
Depends: build-essential, ninja-build, libtorch-dev, libtorch-test
Features: test-name=10_of_147__cpptest__NamedTensor_test
Restrictions: allow-stderr

# C++ test 10/147
Test-Command: /usr/lib/libtorch-test/NeuralNetTest
Depends: build-essential, ninja-build, libtorch-dev, libtorch-test
Features: test-name=11_of_147__cpptest__NeuralNetTest
Restrictions: allow-stderr

# C++ test 11/147
Test-Command: /usr/lib/libtorch-test/SubgraphMatcherTest
Depends: build-essential, ninja-build, libtorch-dev, libtorch-test
Features: test-name=12_of_147__cpptest__SubgraphMatcherTest
Restrictions: allow-stderr

# C++ test 12/147
Test-Command: /usr/lib/libtorch-test/TarjansImplTest
