=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%pytorch-$1.tar.gz%" \
    https://github.com/pytorch/pytorch/releases \
    (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
